// 2003-11-08 programmeerimisvistluse algajate 2. lesande lahendus
// lesanne: SUGULASED
// Autor: Andrei Solntsev, Ahto Truu
// Testitud: JDK 1.2.2 / Win32

// Leiab ekvivalentsiklassid "pratud" puude abil.

import java.io.*;
import java.util.*;

public class suglah1
{
    static final String sisf = "SUG.SIS"; // sisendfaili nimi
    static final String valf = "SUG.VAL"; // vljundfaii nimi

	public static void main(String[] args)
    throws IOException
	{
        StringTokenizer st; // abivahend sisendridade parsimiseks

        // alustame sisendi lugemist
        BufferedReader sis = new BufferedReader(new FileReader(sisf));
        st = new StringTokenizer(sis.readLine()); // loeme esimese rea
        int n = Integer.parseInt(st.nextToken()); // klaliste arv
        int k = Integer.parseInt(st.nextToken()); // sugulusseoste arv

        // alguses on iga klaline eraldi grupis
        int[] y = new int[n + 1]; // y[a] on klalise a vahetu lemus
        for (int a = 1; a <= n; ++a)
            y[a] = 0;

        // loeme sugulusseosed ja hendame grupid
        for (int i = 0; i < k; ++i) {
            st = new StringTokenizer(sis.readLine());
            int a = Integer.parseInt(st.nextToken());
            int b = Integer.parseInt(st.nextToken());
            // leiame klalise a grupi esindaja
            while (y[a] > 0)
                a = y[a];
            // leiame klalise b grupi esindaja
            while (y[b] > 0)
                b = y[b];
            // kui juba pole samas grupis, hendame grupid
            if (a != b)
                y[b] = a;
        }
        sis.close();

        // loendame grupid
        int m = 0;
        for (int a = 1; a <= n; ++a)
            if (y[a] == 0)
                ++m;

        // vljastame vastuse
        PrintWriter val = new PrintWriter(new FileWriter(valf));
        val.println(m);
        int i = 1;
        for (int a = 1; a <= n; ++a)
            if (y[a] == 0) {
                if (i < m)
                    val.print(a + " ");
                else
                    val.println(a);
                ++i;
            }
        val.close();    
    }
}
