{ 2003-11-08 programmeerimisvistluse algajate 2. lesande lahendus         }
{ lesanne: SUGULASED                                                       }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Leiab graafi sidususkomponendid sgavuti lbimisega.                      }
{ Kasutab ilmutatud magasini.                                               }

const
   sisf = 'SUG.SIS';                                     { sisendfaili nimi }
   valf = 'SUG.VAL';                                    { vljundfaili nimi }
   maxn = 100;                                  { maksimaalne klaliste arv }

{ magasin ja operatsioonid sellega }

type
   magasin = record
      n : integer;                                         { elementide arv }
      a : array [1..maxn] of integer;                  { klaliste indeksid }
   end;

procedure alga(var m : magasin);
begin
   m.n := 0;
end;

function tyhi(var m : magasin) : boolean;
begin
   tyhi := (m.n = 0);
end;

procedure pane(var m : magasin; x : integer);
begin
   m.n := m.n + 1;
   m.a[m.n] := x;
end;

procedure vota(var m : magasin; var x : integer);
begin
   x := m.a[m.n];
   m.n := m.n - 1;
end;

{ klalised ja nende sugulusseosed }

type
   persoon = record
      n : integer;                                          { sugulaste arv }
      s : array [1..maxn] of integer;                           { sugulased }
      g : integer;                                           { grupi number }
   end;

var
   n, k, m : integer;
   p : array [1..maxn] of persoon;

procedure margi_grupp(a, g : integer);
var x : magasin; i, b : integer;
begin
   alga(x);
   p[a].g := g; pane(x, a);
   while not tyhi(x) do begin
      vota(x, a);
      for i := 1 to p[a].n do begin
         b := p[a].s[i];
         if p[b].g = 0 then begin
            p[b].g := g; pane(x, b);
         end;
      end;
   end;
end;

var
   f : text;
   i, a, b : integer;
begin
   { seame algseisu }
   for a := 1 to maxn do begin
      p[a].n := 0;
      p[a].g := 0;
   end;

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n, k);
   for i := 1 to k do begin
      readln(f, a, b);
      p[a].n := p[a].n + 1;
      p[a].s[p[a].n] := b;
      p[b].n := p[b].n + 1;
      p[b].s[p[b].n] := a;
   end;
   close(f);

   { lahendame lesande }
   m := 0;
   for a := 1 to n do
      if p[a].g = 0 then begin
         m := m + 1;
         margi_grupp(a, m);
      end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, m);
   i := 1;
   for a := 1 to n do
      if p[a].g = i then begin
         if i < m then
            write(f, a, ' ')
         else
            writeln(f, a);
         i := i + 1;
      end;
   close(f);
end.
