{ 2003-11-08 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{ lesanne: TABEL                                                           }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32                                               }

{ Otsib esimese rea igat elementi kigist jrgmistest ridadest kahend-      }
{ otsingu abil. Kulutab maksimaalselt V*R*log(V) sammu.                     }

const
   sisf = 'TBL.SIS';                                     { sisendfaili nimi }
   valf = 'TBL.VAL';                                    { vljundfaili nimi }
   maxr = 500;                                     { maksimaalne ridade arv }
   maxv = 500;                                   { maksimaalne veergude arv }

var
   r, v : integer;                                          { tabeli suurus }
   a : array [1..maxr, 1..maxv] of integer;              { tabeli elemendid }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   k, i, j, j1, j2  : integer;                 { abimuutujad korduste jaoks }
   ok : boolean;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, r, v);
   for i := 1 to r do begin
      for j := 1 to v do
         read(f, a[i, j]);
      readln(f);
   end;
   close(f);

   ok := true; { vajalik 1-realise tabeli jaoks }
   { kontrollime kiki esimese rea elemente }
   for k := 1 to v do begin
      { kontrollime, kas a[1, k] esineb kigis jrgmistes ridades }
      for i := 2 to r do begin
         { kontrollime, kas a[1, k] esineb i. reas }
         ok := false; { eeldame, et ei esine }
         { kahendotsing i. reas }
         j1 := 1; j2 := v + 1;
         while j1 < j2 do begin
            j := (j1 + j2) div 2;
            if a[i, j] < a[1, k] then
               j1 := j + 1
            else
               j2 := j;
         end;
         if j1 <= v then
            if a[i, j1] = a[1, k] then
               ok := true;
         { kui a[1, k] i. reas ei esinenud, siis lejnud ridu ei uuri }
         if not ok then
            break;
      end;
      { kui a[1, k] esines kigis ridades, siis on JAH-vastus kes }
      if ok then
         break;
   end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   if ok then begin
      writeln(f, 'JAH');
      writeln(f, a[1, k]);
   end else begin
      writeln(f, 'EI');
   end;
   close(f);
end.
