{ 2003-11-08 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{ lesanne: TABEL                                                           }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32                                               }

{ Otsib esimese rea igat elementi kigist jrgmistest ridadest lineaarse    }
{ otsingu abil, aga jtkab jrgmise elemendi otsimist sealt, kus eelmise    }
{ otsimise lpetas. Kulutab maksimaalselt R*V sammu.                        }

const
   sisf = 'TBL.SIS';                                     { sisendfaili nimi }
   valf = 'TBL.VAL';                                    { vljundfaili nimi }
   maxr = 500;                                     { maksimaalne ridade arv }
   maxv = 500;                                   { maksimaalne veergude arv }

var
   r, v : integer;                                          { tabeli suurus }
   a : array [1..maxr, 1..maxv] of integer;              { tabeli elemendid }
   p : array [2..maxr] of integer;                  { jooksvad positsioonid }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   k, i, j : integer;                          { abimuutujad korduste jaoks }
   ok : boolean;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, r, v);
   for i := 1 to r do begin
      for j := 1 to v do
         read(f, a[i, j]);
      readln(f);
   end;
   close(f);

   { algvrtustame lhtepositsioonid }
   for i := 2 to r do
      p[i] := 1;
   ok := true; { vajalik 1-realise tabeli jaoks }
   { kontrollime kiki esimese rea elemente }
   for k := 1 to v do begin
      { kontrollime, kas a[1, k] esineb kigis jrgmistes ridades }
      for i := 2 to r do begin
         { jtame vahele i. rea a[1, k]'st viksemad elemendid }
         while true do begin
            { kui reas rohkem elemente pole, siis katkestame }
            if p[i] = v then
               break;
            { kui jooksev element on piisavalt suur, siis katkestame }
            if a[i, p[i]] >= a[1, k] then
               break;
            { muidu vaatleme jrgmist elementi }
            p[i] := p[i] + 1;
         end;
         { kui a[1, k] esineb i. reas, on ta a[i, p[i]] }
         ok := (a[i, p[i]] = a[1, k]);
         { kui a[1, k] i. reas ei esinenud, siis lejnud ridu ei uuri }
         if not ok then
            break;
      end;
      { kui a[1, k] esines kigis ridades, siis on JAH-vastus kes }
      if ok then
         break;
   end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   if ok then begin
      writeln(f, 'JAH');
      writeln(f, a[1, k]);
   end else begin
      writeln(f, 'EI');
   end;
   close(f);
end.
