{ 2003-11-08 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: TUTVUMINE                                                       }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Kasutab ahnet algoritmi ja annab mnes testis ebaoptimaalse vastuse.      }

const
   sisf = 'TUT.SIS';                                     { sisendfaili nimi }
   valf = 'TUT.VAL';                                    { vljundfaili nimi }
   maxn = 100;

type
   persoon = record
      t : array [1..maxn] of boolean;                            { tuttavad }
      x : array [1..maxn] of boolean;                     { keelatud grupid }
      g : integer;                                           { grupi number }
   end;

var
   n, k, m : integer;
   p : array [1..maxn] of persoon;
   f : text;
   i, a, b, g : integer;

begin
   { seame algseisu }
   for a := 1 to maxn do begin
      for b := 1 to maxn do
         p[a].t[b] := false;
      for g := 1 to maxn do
         p[a].x[g] := false;
      p[a].g := 0;
   end;

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n, k);
   for i := 1 to k do begin
      readln(f, a, b);
      p[a].t[b] := true;
      p[b].t[a] := true;
   end;
   close(f);

   { mrame grupid }
   for a := 1 to n do begin
      { valime esimese vaba grupi }
      g := 1;
      while p[a].x[g] do
         g := g + 1;
      { tuttavad ei vi samas grupis olla }
      for b := 1 to n do
         if p[a].t[b] then
            p[b].x[g] := true;
      p[a].g := g;
   end;

   { loendame grupid }
   m := 0;
   for a := 1 to n do
      if p[a].g > m then
         m := p[a].g;

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   writeln(f, m);
   for a := 1 to n do begin
      write(f, p[a].g);
      if a < n then
         write(f, ' ')
      else
         writeln(f);
   end;
   close(f);
end.
