{ 2003-11-08 programmeerimisvistluse algajate 2. lesande tester           }
{ lesanne: SUGULASED                                                       }
{ Autor: Ahto Truu                                                          }

{$I+}

const
   maxn = 100;

type
   persoon = record
      n : integer; { sugulaste arv }
      s : array [1..maxn] of integer; { sugulased }
      g : integer; { grupi number }
   end;

var
   f : text;
   n, k : integer;
   p : array [1..maxn] of persoon;
   m : integer;
   g : array [1..maxn] of integer;
   mm : integer;
   i, a, b : integer;

procedure margi_grupp(x : integer);
var i : integer;
begin
   p[x].g := mm;
   for i := 1 to p[x].n do
      if p[p[x].s[i]].g = 0 then
         margi_grupp(p[x].s[i]);
end;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   { seame algseisu }
   for i := 1 to maxn do begin
      p[i].n := 0;
      p[i].g := 0;
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, n, k);
   for i := 1 to k do begin
      readln(f, a, b);
      p[a].n := p[a].n + 1;
      p[a].s[p[a].n] := b;
      p[b].n := p[b].n + 1;
      p[b].s[p[b].n] := a;
   end;
   close(f);

   { loeme vljundandmed }
   assign(f, paramstr(2)); reset(f);
   read(f, m);
   if not seekeoln(f) then
      writeln('Liigsed smbolid rea lpus');
   readln(f);
   for i := 1 to m do begin
      if seekeoln(f) then begin
         writeln('Enneaegne rea lpp');
         halt(1);
      end;
      read(f, g[i]);
      if (g[i] < 1) or (g[i] > n) then begin
         writeln('Lubamatu grupiliige ', g[i]);
         halt(1);
      end;
   end;
   if not seekeoln(f) then
      writeln('Liigsed smbolid rea lpus');
   readln(f);
   if not eof(f) then
      writeln('Liigsed read faili lpus');
   close(f);

   { lahendame lesande ;) }
   mm := 0;
   for i := 1 to n do
      if p[i].g = 0 then begin
         mm := mm + 1;
         margi_grupp(i);
      end;

   { kontrollime koosklalisust }
   for a := 1 to m do
      for b := a + 1 to m do
         if p[g[a]].g = p[g[b]].g then begin
            writeln('Klalised ', g[a], ' ja ', g[b], ' ei vi olla samas grupis');
            halt(1);
         end;
   writeln('Grupp koosklaline');

   { kontrollime optimaalsust }
   if m <> mm then begin
      writeln('Grupi suurus ', m, ', peaks olema ', mm);
      halt(1);
   end;

   { muidu OK }
   writeln('Korras');
end.
