{ 2003-11-08 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{ lesanne: TABEL                                                           }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Tlgendab tabeli ridu hulkadena, arvutab nende kigi hisosa R*V sammuga. }

const
   sisf = 'TBL.SIS';                                     { sisendfaili nimi }
   valf = 'TBL.VAL';                                    { vljundfaili nimi }
   maxv = 500;                                   { maksimaalne veergude arv }

type
   hulk = record
      n : integer;                                         { elementide arv }
      a : array [1..maxv] of integer;                 { elemendid kasvavalt }
   end;

{ lisab hulka uue elemendi, eeldab, et see pole viksem kui senised }
procedure lisa(var h : hulk; x : integer);
begin
   { esimene element alati uus, muidu kontrollime, et poleks korduvaid }
   if (h.n = 0) or (h.a[h.n] < x) then begin
      h.n := h.n + 1;
      h.a[h.n] := x;
   end;
end;

{ loeb failist he rea hulgaks }
procedure loe(var f : text; var h : hulk);
var x : integer;
begin
   { hulk thjaks, edasi loeme ja lisame elemente rea lpuni }
   h.n := 0;
   while not seekeoln(f) do begin
      read(f, x);
      lisa(h, x);
   end;
   readln(f);
end;

{ arvutab h1 := h1 ja h2 hisosa }
procedure yhis(var h1, h2 : hulk);
var hh : hulk; { siia tuleb vastus, tegelikult saaks ka ilma selleta }
var i1, i2 : integer;
begin
   hh.n := 0;
   i1 := 1; i2 := 1;
   while (i1 <= h1.n) and (i2 <= h2.n) do begin
      if h1.a[i1] < h2.a[i2] then begin
         i1 := i1 + 1;
      end else if h1.a[i1] > h2.a[i2] then begin
         i2 := i2 + 1;
      end else begin
         lisa(hh, h1.a[i1]);
         i1 := i1 + 1;
         i2 := i2 + 1;
      end;
   end;
   h1 := hh;
end;

var
   r, v : integer;                                          { tabeli suurus }
   hh : hulk;                                      { seniste ridade hisosa }
   h : hulk;                                                 { jooksev rida }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   i : integer;

begin
   { loeme sisendandmed ja arvutame jooksvalt hisosa }
   assign(f, sisf); reset(f);
   readln(f, r, v);
   loe(f, hh);
   for i := 2 to r do begin
      loe(f, h);
      yhis(hh, h);
   end;
   close(f);

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   if hh.n > 0 then begin
      writeln(f, 'JAH');
      writeln(f, hh.a[1]);
   end else begin
      writeln(f, 'EI');
   end;
   close(f);
end.
