{ 2003-11-08 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: TUTVUMINE                                                       }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Kasutab "iteratiivse laiendamise" meetodit.                               }

const
   sisf = 'TUT.SIS';                                     { sisendfaili nimi }
   valf = 'TUT.VAL';                                    { vljundfaili nimi }
   maxn = 100;

type
   persoon = record
      t : array [1..maxn] of boolean;                            { tuttavad }
      k : integer;                               { sidususkomponendi number }
      x : array [1..maxn] of integer;                     { keelatud grupid }
      g : integer;                                           { grupi number }
   end;

var
   n, k, m : integer;
   p : array [1..maxn] of persoon;
   q : array [1..maxn] of integer;         { klaliste ttlemise jrjekord }

{ lisab sidususkomponendi elemendid jrjekorda }
procedure margi_komp(a, k : integer; var i : integer);
var b : integer;
begin
   { mrgime klalise komponendi }
   p[a].k := k;
   { paneme klalise jrjekorda }
   i := i + 1; q[i] := a;
   { ttleme tuttavad }
   for b := 1 to n do
      if p[a].t[b] then
         if p[b].k = 0 then
            margi_komp(b, k, i);
end;

{ proovib panna klalise q[i] gruppi gg }
function pane(i, gg : integer) : boolean;
var a, b, g : integer;
begin
   { eeldame, et nnestub }
   pane := true;
   { paneme gruppi }
   a := q[i]; p[a].g := gg;
   { tuttavad ei vi samas grupis olla }
   for b := 1 to n do
      if p[a].t[b] then
         p[b].x[gg] := p[b].x[gg] + 1;
   if i = n then
      exit;                                      { kui viimane, siis valmis }
   b := q[i + 1];
   if p[a].k < p[b].k then
      exit;                      { kui oma komponendis viimane, siis valmis }
   { proovime leida gruppi jrgmistele }
   for g := 1 to m do
      if p[b].x[g] = 0 then
         if pane(i + 1, g) then
            exit;                               { kui nnestus, siis valmis }
   { ebannestus, vtame sammu tagasi }
   for b := 1 to n do
      if p[a].t[b] then
         p[b].x[gg] := p[b].x[gg] - 1;
   pane := false;
end;

var
   f : text;
   i, a, b, g : integer;
begin
   { seame algseisu }
   for a := 1 to maxn do begin
      for b := 1 to maxn do
         p[a].t[b] := false;
      p[a].k := 0;
      for g := 1 to maxn do
         p[a].x[g] := 0;
      p[a].g := 0;
   end;

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n, k);
   for i := 1 to k do begin
      readln(f, a, b);
      p[a].t[b] := true;
      p[b].t[a] := true;
   end;
   close(f);

   { leiame sidususkomponendid ja moodustame jrjekorra }
   k := 0; i := 0;
   for a := 1 to n do
      if p[a].k = 0 then begin
         k := k + 1;
         margi_komp(a, k, i);
      end;

   { mrame grupid }
   m := 1;
   for i := 1 to n do                             { vaatleme kiki klalisi }
      if p[q[i]].g = 0 then                     { kui on gruppi paigutamata }
         while not pane(i, 1) do               { otsime m grupiga lahendust }
            m := m + 1;  { kui ei leidnud, proovime suurema gruppide arvuga }

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   writeln(f, m);
   for a := 1 to n do begin
      write(f, p[a].g);
      if a < n then
         write(f, ' ')
      else
         writeln(f);
   end;
   close(f);
end.
