{ 2003-11-08 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: TUTVUMINE                                                       }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.6 / Win32, TPC 6.0                                      }

{ Kasutab randomiseeritud algoritmi.                                        }

uses
   dos;

const
   sisf = 'TUT.SIS';                                     { sisendfaili nimi }
   valf = 'TUT.VAL';                                    { vljundfaili nimi }
   maxn = 100;
   aega = 5.0 - 0.5;                 { ajalimiit, osa jtame salvestamiseks }

type
   persoon = record
      t : array [1..maxn] of boolean;                            { tuttavad }
      k : integer;                               { sidususkomponendi number }
      x : array [1..maxn] of boolean;                     { keelatud grupid }
      g, gg : integer;                    { grupi number (jooksev ja parim) }
   end;

var
   n, k, m, mm : integer;
   p : array [1..maxn] of persoon;
   q : array [1..maxn] of integer;         { klaliste ttlemise jrjekord }

{ tagastab kellaaja sekundites }
function kell : real;
var h, m, s, ss : word;
begin
   gettime(h, m, s, ss);
   kell := (h * 60.0 + m) * 60.0 + s + ss / 100;
end;

{ lisab sidususkomponendi elemendid jrjekorda }
procedure margi_komp(a, k : integer; var i : integer);
var b : integer;
begin
   { mrgime klalise komponendi }
   p[a].k := k;
   { paneme klalise jrjekorda }
   i := i + 1; q[i] := a;
   { ttleme tuttavad }
   for b := 1 to n do
      if p[a].t[b] then
         if p[b].k = 0 then
            margi_komp(b, k, i);
end;

{ salvestab lahenduse kui seni parima }
procedure salvesta;
var a : integer;
begin
   for a := 1 to n do
      p[a].gg := p[a].g;
   mm := m;
end;

label
   tupik;
var
   f : text;
   i, a, b, g : integer;
   tt : real;                                          { lpetamise thtaeg }
begin
   { mrame lpetamise thtaja }
   tt := kell + aega;            { NB! ttab valesti vahetult enne sdad }

   { seame algseisu }
   for a := 1 to maxn do begin
      for b := 1 to maxn do
         p[a].t[b] := false;
      p[a].k := 0;
      p[a].g := 0;
   end;

   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n, k);
   for i := 1 to k do begin
      readln(f, a, b);
      p[a].t[b] := true;
      p[b].t[a] := true;
   end;
   close(f);

   { leiame sidususkomponendid ja moodustame jrjekorra }
   k := 0; i := 0;
   for a := 1 to n do
      if p[a].k = 0 then begin
         k := k + 1;
         margi_komp(a, k, i);
      end;

   { mrame grupid }
   m := n;
   while kell < tt do begin
      { seame algseisu }
      for a := 1 to n do
         for g := 1 to m do
            p[a].x[g] := false;
      { otsime igale klalisele gruppi }
      for i := 1 to n do begin
         a := q[i];
         { loendame vabad grupid }
         k := 0;
         for g := 1 to m do
            if not p[a].x[g] then
               k := k + 1;
         { kui vabu gruppe pole, oleme tupikus ja proovime uuesti }
         if k = 0 then
            goto tupik;
         { muidu valime juhuslikult grupi ja paneme a sinna }
         k := random(k);
         for g := 1 to m do
            if not p[a].x[g] then begin
               if k = 0 then
                  p[a].g := g;
               k := k - 1;
            end;
         { a tuttavad ei vi samas grupis olla }
         for b := 1 to n do
            if p[a].t[b] then
               p[b].x[p[a].g] := true;
      end;
      salvesta;                                      { salvestame lahenduse }
      m := m - 1;                         { ja edaspidi otsime juba paremat }
tupik:                                      { tupiku korral proovime uuesti }
   end;

   { vljastame tulemuse }
   assign(f, valf); rewrite(f);
   writeln(f, mm);
   for a := 1 to n do begin
      write(f, p[a].gg);
      if a < n then
         write(f, ' ')
      else
         writeln(f);
   end;
   close(f);
end.
